Module java.base
Package java.lang.annotation

# Enum Class RetentionPolicy

java.lang.Object
java.lang.Enum<RetentionPolicy>
java.lang.annotation.RetentionPolicy

All Implemented Interfaces:
  `Serializable`, `Comparable<RetentionPolicy>`, `Constable`

public enum RetentionPolicy extends Enum<RetentionPolicy>
Annotation retention policy. The constants of this enumerated class describe the various policies for retaining annotations. They are used in conjunction with the `Retention` meta-annotation interface to specify how long annotations are to be retained.

Since:
  1.5

## Nested Class Summary

## Nested classes/interfaces declared in class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`CLASS`
Annotations are to be recorded in the class file by the compiler but need not be retained by the VM at run time.
`RUNTIME`
Annotations are to be recorded in the class file by the compiler and retained by the VM at run time, so they may be read reflectively.
`SOURCE`
Annotations are to be discarded by the compiler.

## Method Summary

Modifier and Type
Method
Description
`static RetentionPolicy`
`valueOf​(String name)`
Returns the enum constant of this class with the specified name.
`static RetentionPolicy[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods declared in class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods declared in class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### SOURCE

public static final RetentionPolicy SOURCE
Annotations are to be discarded by the compiler.

### CLASS

public static final RetentionPolicy CLASS
Annotations are to be recorded in the class file by the compiler but need not be retained by the VM at run time. This is the default behavior.

### RUNTIME

public static final RetentionPolicy RUNTIME
Annotations are to be recorded in the class file by the compiler and retained by the VM at run time, so they may be read reflectively.

See Also:
  `AnnotatedElement`

## Method Details

### values

public static RetentionPolicy[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static RetentionPolicy valueOf​(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null